<template>
	<section id="create" class="m-auto container h-screen py-12">
		<h1 class="mb-5 w-2/4 m-auto text-3xl text-center">Créer une carte</h1>
		<form @submit="submitForm" class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-12 w-2/4 m-auto">
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="name">
					Nom
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="name"
				       name="name"
				       type="text"
				       v-model="dataForm.name"
				       placeholder="Nom de la carte"
				       required>
			</div>
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="key">
					Référence
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
				       id="key"
				       name="key"
				       type="text"
				       v-model="dataForm.key"
				       placeholder="WSUP-FR010"
				       required>
			</div>
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="description">
					Description
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="description"
				       name="description"
				       type="text"
				       v-model="dataForm.description"
				       placeholder="Description de la carte"
				       required>
			</div>
			<div class="mb-4">
				<label class="block text-sm font-bold mb-2" for="amount">
					Quantité
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="amount"
				       name="amount"
				       type="number"
				       v-model.number="dataForm.amount"
				       placeholder="Quantité"
				       min="1"
				       required>
			</div>
			<div class="mb-6">
				<label class="block text-sm font-bold mb-2" for="card_image">
					Image
				</label>
				<input class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
				       id="card_image"
				       name="card_image"
				       ref="file"
				       v-on:change="handleInputFile()"
				       type="file"
				       required>
			</div>
			<div class="flex items-center justify-between">
				<button class="bg-red-600 hover:bg-red-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
				        type="submit">
					Valider
				</button>
			</div>
			<!-- Handle message error -->
			<div v-if="error !== null"
			     class="mt-6 bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative" role="alert">
				<strong class="font-bold">Une erreur est survenue!</strong>
				<span class="block sm:inline">{{error}}</span>
			</div>
		</form>
	</section>
</template>

<script>
	import ApiService from '../services/ApiService'
	import AuthService from '../services/AuthService'
	import {mapGetters} from 'vuex'

	export default {
		data () {
			return {
				dataForm: {},
				error: null
			}
		},
		computed: {
			...mapGetters([
				'token',
			])
		},
		methods: {
			async submitForm (e) {
				e.preventDefault()

				this.error = null

				const data = new FormData()

				for (const key in this.dataForm) {
					if (this.dataForm.hasOwnProperty(key)) {
						data.append(key, this.dataForm[key])
					}
				}

				try {
					await ApiService.request({
						url: '/cards',
						method: 'post',
						headers: {Authorization: `Bearer ${this.token}`},
						data
					})

					return this.$router.push('/')
				} catch (e) {
					this.error = 'Veuillez réessayer plus tard.'
				}
			},
			handleInputFile () {
				this.dataForm.card_image = this.$refs.file.files[0]
			}
		}
	}
</script>
